---
title: 'ARIA: gridcell role'
slug: Web/Accessibility/ARIA/Roles/Gridcell_role
tags:
  - ARIA
  - HTML
---
<p>{{Page("/en-US/docs/Web/Accessibility/ARIA/Roles", "Subnav")}}</p>

<p><span class="seoSummary">The <a href="https://www.w3.org/TR/wai-aria-1.1/#gridcell">gridcell role</a> is used to make a cell in a <a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Grid_Role">grid</a> or <a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Treegrid_role">treegrid</a>. It is intended to mimic the functionality of the <a href="/en-US/docs/Web/HTML/Element/td">HTML <code>td</code> element</a> for table-style grouping of information.</span></p>

<pre class="brush: html">&lt;div role="gridcell"&gt;Potato&lt;/div&gt;
&lt;div role="gridcell"&gt;Cabbage&lt;/div&gt;
&lt;div role="gridcell"&gt;Onion&lt;/div&gt;
</pre>

<p>Elements that have <code>role="gridcell"</code> applied to them must be the child of an element with a role of <code><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Row_Role">row</a></code>.</p>

<pre class="brush: html">&lt;div role="row"&gt;
  &lt;div role="gridcell"&gt;Jane&lt;/div&gt;
  &lt;div role="gridcell"&gt;Smith&lt;/div&gt;
  &lt;div role="gridcell"&gt;496-619-5098&lt;/div&gt;
  …
&lt;/div&gt;
</pre>

<p>The first rule of ARIA is if a native HTML element or attribute has the semantics and behavior you require, use it instead of re-purposing an element and adding ARIA. Instead use the native <a href="/en-US/docs/Web/HTML/Element/td">HTML <code>td</code> element</a> in conjunction with the and <a href="/en-US/docs/Web/HTML/Global_attributes/contenteditable"><code>contenteditable</code> attribute</a>:</p>

<pre class="brush: html">&lt;td&gt;Potato&lt;/td&gt;
&lt;td&gt;Cabbage&lt;/td&gt;
&lt;td&gt;Onion&lt;/td&gt;</pre>

<h2 id="Description">Description</h2>

<h3 id="gridcells_with_dynamically_added_hidden_or_removed_rows_and_columns">gridcells with dynamically added, hidden, or removed rows and columns</h3>

<p>Any element with a <code>role="gridcell"</code> applied to it should use ARIA to describe its order in the table-style grouping, provided the table, grid, or treegrid has the ability to have rows and/or columns dynamically added, hidden, or removed.</p>

<p>Use <code>aria-colindex</code> to describe a <code>gridcell</code>'s order in the list of columns, and <code>aria-rowindex</code> to describe a gridcell's order in the list of rows. Use <code>aria-colcount</code> and <code>aria-rowcount</code> on the parent element with <code><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Grid_Role">role="grid"</a></code> applied to it to set the total number of columns or rows.</p>

<p>This sample code demonstrates a table-style grouping of information where the third and fourth columns have been removed. <code>aria-colindex</code> is being used to describe the rows' position and allows a person using assistive technology to infer that certain rows have been removed:</p>

<pre class="brush: html">&lt;div role="grid" aria-colcount="6"&gt;
  &lt;div role="rowgroup"&gt;
    &lt;div role="row"&gt;
      &lt;div role="columnheader" aria-colindex="1"&gt;First name&lt;/div&gt;
      &lt;div role="columnheader" aria-colindex="2"&gt;Last name&lt;/div&gt;
      &lt;div role="columnheader" aria-colindex="5"&gt;City&lt;/div&gt;
      &lt;div role="columnheader" aria-colindex="6"&gt;Zip&lt;/div&gt;
    &lt;/div&gt;
  &lt;/div&gt;
  &lt;div role="rowgroup"&gt;
    &lt;div role="row"&gt;
      &lt;div role="gridcell" aria-colindex="1"&gt;Debra&lt;/div&gt;
      &lt;div role="gridcell" aria-colindex="2"&gt;Burks&lt;/div&gt;
      &lt;div role="gridcell" aria-colindex="5"&gt;New York&lt;/div&gt;
      &lt;div role="gridcell" aria-colindex="6"&gt;14127&lt;/div&gt;
    &lt;/div&gt;
  &lt;/div&gt;
  …
&lt;/div&gt;
</pre>

<h3 id="Describing_the_position_of_gridcells_when_the_overall_structure_is_unknown">Describing the position of gridcells when the overall structure is unknown</h3>

<p>In situations where the table-style grouping of content does not provide information about the columns and rows, gridcells must have their positions programatically described by using <code><a href="/en-US/docs/Web/Accessibility/ARIA/ARIA_Techniques/Using_the_aria-describedby_attribute">aria-describedby</a></code>. The <code><a href="/en-US/docs/Web/HTML/Global_attributes/id">id</a></code>s provided for <code>aria-describedby</code> should correspond to parent elements intended to be the rows and columns.</p>

<p>By referencing the parent elements with roles of <code><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Rowheader_role">rowheader</a></code> or <code><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Columnheader_role">columnheader</a></code> applied to them via <code>aria-describedby</code>, it allows assistive technology to understand the position and relationship of the <code>gridcell</code> element to the rest of the table-style grouping of content.</p>

<h3 id="Interactive_grids_and_treegrids">Interactive grids and treegrids</h3>

<h4 id="Editable_cells">Editable cells</h4>

<p>Both <code>td</code> elements and elements with a role of <code>gridcell</code> applied to them can be made editable, mimicking functionality similar to editing a spreadsheet. This is done by applying the HTML <a href="/en-US/docs/Web/HTML/Global_attributes/contenteditable"><code>contenteditable</code> attribute</a>. </p>

<pre class="brush: html">&lt;td contenteditable="true"&gt;Notes&lt;/td&gt;

&lt;div role="gridcell" contenteditable="true"&gt;Item cost&lt;/div&gt;
</pre>

<p><code>contenteditable</code> will make the element it is applied to focusable via the <kbd>Tab</kbd> key. If a gridcell is conditionally toggled into a state where editing is prohibited, toggle <code><a href="/en-US/docs/Web/Accessibility/ARIA/ARIA_Techniques/Using_the_aria-readonly_attribute">aria-readonly</a></code> on the gridcell element.</p>

<h4 id="Expandable_cells">Expandable cells</h4>

<p>In a <a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Treegrid_role">treegrid</a>, gridcells may be made expandable by toggling the <code>aria-expanded</code> attribute. Note that if this attribute is provided, it applies only to the individual gridcell.</p>

<h3 id="Associated_WAI-ARIA_Roles_States_and_Properties">Associated WAI-ARIA Roles, States, and Properties</h3>

<dl>
 <dt>grid</dt>
 <dd>
 <p>Communicates that a parent element is a table or tree style grouping of information.</p>
 </dd>
 <dt>row</dt>
 <dd>
 <p>Required to communicate the <code>gridcell</code> is part of a row of a table-style grouping of information.</p>
 </dd>
 <dt>columnheader</dt>
 <dd>
 <p>Specifies which element is the associated column header.</p>
 </dd>
 <dt>aria-colindex</dt>
 <dd>
 <p>Identifies the position of an element in relation to the rest of the table-style grouping of information's columns.</p>
 </dd>
 <dt>rowheader</dt>
 <dd>Specifies which element is the associated row header.</dd>
 <dt>aria-rowindex</dt>
 <dd>
 <p>Identifies the position of an element in relation to the rest of the table-style grouping of information's rows.</p>
 </dd>
</dl>

<h3 id="Examples">Examples</h3>

<p>The following example creates a table-style grouping of information:</p>

<pre class="brush: html">&lt;h3 id="table-title"&gt;Jovian gas giant planets&lt;/h3&gt;
&lt;div role="grid" aria-describedby="table-title"&gt;
  &lt;div role="rowgroup"&gt;
    &lt;div role="row"&gt;
      &lt;div role="columnheader"&gt;Name&lt;/div&gt;
      &lt;div role="columnheader"&gt;Diameter (km)&lt;/div&gt;
      &lt;div role="columnheader"&gt;Length of day (hours)&lt;/div&gt;
      &lt;div role="columnheader"&gt;Distance from Sun (10&lt;sup&gt;6&lt;/sup&gt;km)&lt;/div&gt;
      &lt;div role="columnheader"&gt;Number of moons&lt;/div&gt;
    &lt;/div&gt;
  &lt;/div&gt;
  &lt;div role="rowgroup"&gt;
    &lt;div role="row"&gt;
      &lt;div role="gridcell"&gt;Jupiter&lt;/div&gt;
      &lt;div role="gridcell"&gt;142,984&lt;/div&gt;
      &lt;div role="gridcell"&gt;9.9&lt;/div&gt;
      &lt;div role="gridcell"&gt;778.6&lt;/div&gt;
      &lt;div role="gridcell"&gt;67&lt;/div&gt;
    &lt;/div&gt;
  &lt;/div&gt;
  &lt;div role="rowgroup"&gt;
    &lt;div role="row"&gt;
      &lt;div role="gridcell"&gt;Saturn&lt;/div&gt;
      &lt;div role="gridcell"&gt;120,536&lt;/div&gt;
      &lt;div role="gridcell"&gt;10.7&lt;/div&gt;
      &lt;div role="gridcell"&gt;1433.5&lt;/div&gt;
      &lt;div role="gridcell"&gt;62&lt;/div&gt;
    &lt;/div&gt;
  &lt;/div&gt;
&lt;/div&gt;
</pre>

<h2 id="Accessibility_concerns">Accessibility concerns</h2>

<p>Support for <code>gridcell</code> and certain <code>gridcell</code>-related ARIA roles and properties have poor support with assistive technologies. If at all possible, utilize <a href="/en-US/docs/Web/HTML/Element/table">native HTML table markup</a> in their place.</p>

<h2 id="Best_practices">Best practices</h2>

<p>The first rule of ARIA is: if a native HTML element or attribute has the semantics and behavior you require, use it instead of re-purposing an element and adding an ARIA role, state or property to make it accessible. As such, it is recommended to use the utilize <a href="/en-US/docs/Web/HTML/Element/table">native HTML table markup</a> instead of recreating a table's form and functionality with ARIA and JavaScript.</p>

<h2 id="See_also">See also:</h2>

<ul>
 <li><a href="/en-US/docs/Web/HTML/Element/table">The Table element</a></li>
 <li><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Grid_Role">ARIA: Grid role</a></li>
 <li><a href="http://www.maxability.co.in/wai-aria-overview/grid-role/">Grid Role - Maxability</a></li>
 <li><a href="/en-US/docs/Web/HTML/Element/tr">The Table row element</a></li>
 <li><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Grid_Role">ARIA: row role</a></li>
 <li><a href="http://www.maxability.co.in/wai-aria-overview/row-role/">Row Role - Maxability</a></li>
 <li><a href="http://www.maxability.co.in/2018/09/aria-rowcount-property/">aria-rowcount - Maxability</a></li>
 <li><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/rowgroup_Role">ARIA: rowgroup role</a></li>
 <li><a href="http://www.maxability.co.in/wai-aria-overview/rowgroup-role/">Rowgroup Role - Maxability</a></li>
 <li><a href="/en-US/docs/Web/HTML/Element/th">The Table header element</a></li>
 <li><a href="http://www.maxability.co.in/wai-aria-overview/columnheader-role/">Columnheader - Maxability</a></li>
 <li><a href="http://www.maxability.co.in/2017/07/aria-colcount-property/">aria-colcount - Maxability</a></li>
 <li><a href="/en-US/docs/Web/HTML/Element/td">The Table Data Cell element</a></li>
 <li><a href="https://www.w3.org/TR/wai-aria-1.1/#gridcell">gridcell: Accessible Rich Internet Applications (WAI-ARIA) 1.1</a></li>
 <li><a href="http://www.maxability.co.in/wai-aria-overview/gridcell-role/">Gridcell Role - Maxability</a></li>
</ul>
